]> arthur.barton.de Git - backup-script.git/blobdiff - bin/backup-script
Filesystem summary: Use "zfs list" on ZFS filesystems
[backup-script.git] / bin / backup-script
index 326046e0c4ef869286e1642fca6e41b1b01777d5..cf61a7225ef714ba5e42916bfadb9b2dad12500e 100755 (executable)
@@ -26,10 +26,13 @@ declare -i count_ok_vanished=0
 destinations=""
 
 # Default settings, can be overwritten in backup-script.conf:
-conf_d="/etc/backup-script.d"
+[ -d "/usr/local/etc/backup-script.d" ] \
+       && conf_d="/usr/local/etc/backup-script.d" \
+       || conf_d="/etc/backup-script.d"
 pre_exec=""
 post_exec=""
-default_target=""
+default_source_root="/"
+default_target="/var/backups"
 default_user="root"
 default_ssh_args_add=""
 default_rsync_args_add=""
@@ -49,7 +52,9 @@ Usage() {
        echo
        echo "When no <system> is given, all defined systems are used."
        echo
-       exit 1
+       echo -e $config_info
+       echo
+       exit 2
 }
 
 CleanUp() {
@@ -71,12 +76,13 @@ GotSignal() {
        CleanUp
        echo -n "Aborted: "; date
        echo
+       sleep 3
        exit 9
 }
 
 ExecJob() {
-       what="$1"
-       cmd="$2"
+       local what="$1"
+       local cmd="$2"
 
        echo "Running job ${what}-exec command ..."
        [ "$local" -eq 0 ] \
@@ -84,7 +90,7 @@ ExecJob() {
        echo -n "Start date (${what}-exec): "; date
        echo "$cmd"
        if [ "$DRYRUN" -eq 0 ]; then
-               $SHELL -c "$cmd"; ret=$?
+               $SHELL -c "$cmd"; local ret=$?
        else
                echo " *** Trial run, not executing ${what}-exec command!"
                ret=0
@@ -95,32 +101,186 @@ ExecJob() {
        return $ret
 }
 
-CreateSubvolume() {
-       volume="$1"
+GetFS() {
+       local dir="$1"
 
-       btrfs subvolume create "$volume"
+       while [ -n "$dir" ]; do
+               findmnt -fn -o FSTYPE --raw "$dir" 2>/dev/null; local r=$?
+               if [ $r -eq 0 ]; then
+                       return 0
+               elif [ $r -eq 127 ]; then
+                       echo "UNKNOWN"
+                       return 1
+               fi
+               dir=$(dirname "$dir") || return 1
+       done
 }
 
-CloneSubvolume() {
-       source="$1"
-       volume="$2"
+CreateSubvolume() {
+       local volume="$1"
+       local fs
+       local dir
+
+       dir=$(dirname "$volume")
+       fs=$(GetFS "$dir")
+       case "$fs" in
+         "btrfs")
+               btrfs subvolume create "$volume"  >/dev/null || return 1
+               ;;
+         "zfs")
+               zfs create "$(echo "$volume" | cut -c2-)" || return 1
+               ;;
+         *)
+               echo "CreateSubvolume: Incompatible FS type \"$fs\" on \"$dir\"!"
+               return 9
+       esac
+       return 0
+}
 
-       btrfs subvolume snapshot "$source" "$volume"
+CloneSubvolume() {
+       local source="$1"
+       local volume="$2"
+       local snapshot="$3"
+       local dir
+       local fs
+       local link_name
+
+       dir=$(dirname "source")
+       fs=$(GetFS "$source")
+       case "$fs" in
+         "btrfs")
+               btrfs subvolume snapshot "$source" "$snapshot"  >/dev/null || return 1
+               ;;
+         "zfs")
+               zfs snapshot "$snapshot" || return 1
+               link_name="$(echo "$snapshot" | cut -d@ -f2-)"
+               ln -s \
+                       "$volume/.zfs/snapshot/$link_name" \
+                       "$(dirname "$volume")/$link_name"
+               ;;
+         *)
+               echo "CloneSubvolume: Incompatible FS type \"$fs\" on \"$source\"!"
+               return 9
+       esac
+       return 0
 }
 
 RenameSubvolume() {
-       source="$1"
-       target="$2"
-
-       mv "$source" "$target"
+       local source="$1"
+       local target="$2"
+       local fs
+
+       fs=$(GetFS "$source")
+       case "$fs" in
+         "btrfs")
+               mv "$source" "$target" || return 1
+               ;;
+         "zfs")
+               zfs rename \
+                 "$(echo "$source" | cut -c2-)" \
+                 "$(echo "$target" | cut -c2-)" \
+                       || return 1
+               ;;
+         *)
+               echo "RenameSubvolume: Incompatible FS type \"$fs\" on \"$source\"!"
+               return 9
+       esac
+       return 0
 }
 
 DeleteSubvolume() {
-       volume="$1"
+       local volume="$1"
+       local fs
+       local id
+       local snapshot
+
+       fs=$(GetFS "$volume")
+       case "$fs" in
+         "btrfs")
+               btrfs subvolume delete "$volume" >/dev/null || return 1
+               ;;
+         "zfs")
+               id="$(basename "$volume")"
+               if [ -h "$volume" ]; then
+                       snapshot="$(dirname "$volume")/current@$id"
+               else
+                       snapshot="$volume"
+               fi
+               zfs destroy -r "$(echo "$snapshot" | cut -c2-)" >/dev/null || return 1
+               [ -h "$volume" ] && rm "$volume"
+               ;;
+         *)
+               echo "DeleteSubvolume: Incompatible FS type \"$fs\" on \"$volume\"!"
+               return 9
+       esac
+       return 0
+}
+
+Initialize_Last_SysTarget_Snapshot() {
+       sys_target="$1"
+       unset last
+       unset snapshot
+
+       fs=$(GetFS "$sys_target")
+       case "$fs" in
+         "btrfs")
+               # Search directory of last generation, if any
+               last=$(ls -1d "$sys_target"/[0-9]* 2>/dev/null | sort -r | head -n1)
+               if [ -n "$last" ]; then
+                       if [ ! -d "$last" ]; then
+                               echo "Last snapshot \"$last\" seems not to be a directory!? \"$system\" skipped!"
+                               echo
+                               return 1
+                       fi
+               fi
+               sys_target="$sys_target/$(date +%Y%m%d-%H%M%S)"
+               snapshot="$sys_target"
+               ;;
+         "zfs")
+               # On ZFS, the last generation is always named "current"
+               if [ -e "$sys_target/current" ]; then
+                       last="$sys_target/current"
+                       if [ "$(uname)" = "Linux" ]; then
+                               date=$(LC_ALL=C stat "$1" | grep "^Modify: " \
+                                | cut -d':' -f2- | cut -d. -f1)
+                       else
+                               date=$(LC_ALL=C stat -f "%Sc" "$1")
+                       fi
+                       date=$(echo "$date" | sed -e's/^ //g' -e 's/[-:]//g' -e 's/ /-/g')
 
-       btrfs subvolume delete "$volume"
+               else
+                       last=""
+                       date="$(date +%Y%m%d-%H%M%S)"
+               fi
+               snapshot="$(echo "$sys_target/current" | cut -c2-)@$date"
+               sys_target="$sys_target/current"
+               ;;
+         *)
+               echo "Initialize_Last_SysTarget_Snapshot: Incompatible FS type \"$fs\" on \"$sys_target\"!"
+               return 1
+       esac
+       return 0
 }
 
+# Search configuration file (last one is used as default!)
+for conf in \
+       "/usr/local/etc/backup-script.conf" \
+       "/etc/backup-script.conf" \
+       "${conf_d}/backup-script.conf" \
+       "/usr/local/etc/backup-script.conf" \
+; do
+       [ -r "$conf" ] && break
+done
+
+# Read in configuration file
+config_info="Configuration file is \"$conf\""
+if [ -r "$conf" ]; then
+       source "$conf"
+else
+       config_info="${config_info} (not readable, using defaults)"
+fi
+config_info="${config_info},\nusing \"$conf_d\" as configuration directory."
+
 while [ $# -gt 0 ]; do
        case "$1" in
          "-n"|"--dry-run")
@@ -140,20 +300,14 @@ done
 trap GotSignal SIGINT
 
 echo -n "Started: "; date
-
-for conf in "/etc/backup-script.conf" "${conf_d}/backup-script.conf"; do
-       if [ -r "$conf" ]; then
-               echo "Reading configuration: \"$conf\" ..."
-               source "$conf"
-       fi
-done
+echo -e $config_info
 echo
 
 if [ $# -ge 1 ]; then
        for s in "$@"; do
                if [ ! -r "${conf_d}/$s" ]; then
                        echo "$NAME: Can' read \"${conf_d}/$s\"!"
-                       exit 1
+                       exit 3
                fi
                sys="$sys ${conf_d}/$s"
        done
@@ -168,7 +322,7 @@ if [ -e "$PIDFILE" ]; then
        echo
        echo -n "Aborted: "; date
        echo
-       exit 3
+       exit 4
 fi
 touch "$PIDFILE" 2>/dev/null
 if [ $? -ne 0 ]; then
@@ -185,7 +339,7 @@ if [ -n "$pre_exec" ]; then
                echo "Error: pre-exec command failed!"; echo
                CleanUp
                echo "Aborting backup."; echo
-               exit 2
+               exit 5
        fi
        sleep 2
        echo
@@ -204,6 +358,7 @@ for f in $sys; do
        # Set global defaults
        system="$fname"
        user="$default_user"
+       source_root="$default_source_root"
        target="$default_target"
        ssh_args_add="$default_ssh_args_add"
        rsync_args_add="$default_rsync_args_add"
@@ -215,11 +370,54 @@ for f in $sys; do
        job_pre_exec="$default_job_pre_exec"
        job_post_exec="$default_job_post_exec"
 
+       # Compatibility with backup-pull(1) script: Save global values ...
+       pre_exec_saved="$pre_exec"
+       post_exec_saved="$post_exec"
+
+       # Compatibility with backup-pull(1) script: Set defaults
+       unset host
+       unset source
+       unset pre_exec
+       unset post_exec
+
        # Read in system configuration file
        source "$f"
 
+       # Compatibility with backup-pull(1) script: Fix up configuration
+       [ "$system" = "$fname" -a -n "$host" ] \
+               && system="$host"
+       [ "$source_root" = "$default_source_root" -a -n "$source" ] \
+               && source_root="$source"
+       [ -z "$job_pre_exec" -a -n "$pre_exec" ] \
+               && job_pre_exec="$pre_exec"
+       [ -z "$job_post_exec" -a -n "$post_exec" ] \
+               && job_post_exec="$post_exec"
+
+       # Compatibility with backup-pull(1) script: Restore global values ...
+       pre_exec="$pre_exec_saved"
+       post_exec="$post_exec_saved"
+
        # Validate configuration
-       [ "$system" = "localhost" -o "$system" = "127.0.0.1" ] && local=1
+       if [ "$system" = "localhost" -o "$system" = "127.0.0.1" ]; then
+               # Local system
+               local=1
+               compress=0
+       fi
+
+       # Make sure "source" ends with a slash ("/")
+       case "$source" in
+         "*/")
+               ;;
+         "*")
+               source="$source/"
+       esac
+
+       # Make sure "target" DOESN'T end with a slash ("/")
+       case "$target" in
+         "*/")
+               target=$( echo "$target" | sed -e 's/\/$//g' )
+               ;;
+       esac
 
        [ "$system" = "$fname" ] \
                && systxt="\"$system\"" \
@@ -242,8 +440,12 @@ for f in $sys; do
 
        sys_target="$target/$fname"
        sys_root="$sys_target"
-       if [ "$DRYRUN" -eq 0 ]; then
-               mkdir -p "$sys_target" >/dev/null 2>&1
+       if [ "$DRYRUN" -eq 0 -a ! -e "$sys_target" ]; then
+               if [ $generations -gt 0 ]; then
+                       CreateSubvolume "$sys_target"
+               else
+                       mkdir -p "$sys_target"
+               fi
                if [ $? -ne 0 ]; then
                        echo "Can't create \"$sys_target\"!? \"$system\" skipped!"
                        echo; continue
@@ -269,20 +471,12 @@ for f in $sys; do
                        echo; continue
                fi
 
-               # Search directory of last generation, if any
-               last=$(ls -1d "$sys_target"/[0-9]* 2>/dev/null | sort -r | head -n1)
-               if [ -n "$last" ]; then
-                       if [ ! -d "$last" ]; then
-                               echo "Last snapshot \"$last\" seems not to be a directory!? \"$system\" skipped!"
-                               echo; continue
-                       fi
-               fi
-               sys_target="$sys_target/$(date +%Y%m%d-%H%M%S)"
+               Initialize_Last_SysTarget_Snapshot "$sys_target" || continue
 
                if [ -n "$last" -a ! -e "$last/.stamp" ]; then
                        # Old backup directory without "stamp file", continue
                        echo "Found incomplete snapshot in \"$last\", reusing and renaming it ..."
-                       RenameSubvolume "$last" "$sys_target" >/dev/null 2>&1
+                       RenameSubvolume "$last" "$sys_target"
                        if [ $? -ne 0 ]; then
                                echo "Failed to rename last snapshot \"$last\" to \"$sys_target\"!? \"$system\" skipped!"
                                echo; continue
@@ -291,21 +485,19 @@ for f in $sys; do
                        # Old backup directory found, create new snapshot
                        echo "Found last snapshot in \"$last\"."
                        if [ "$DRYRUN" -eq 0 ]; then
-                               CloneSubvolume \
-                                 "$last" "$sys_target" >/dev/null 2>&1; r=$?
+                               CloneSubvolume "$last" "$sys_target" "$snapshot"; r=$?
                                if [ $r -ne 0 ]; then
-                                       echo "Can't create snapshot \"$sys_target\" of \"$last\", code $r!? \"$system\" skipped!"
+                                       echo "Can't create snapshot \"$snapshot\" of \"$last\", code $r!? \"$system\" skipped!"
                                        echo; continue
                                fi
-                               echo "Created new snapshot in \"$sys_target\"."
+                               echo "Created new snapshot in \"$snapshot\"."
                        else
-                               echo " *** Trial run, not creating new snapshot in \"$sys_target\"!"
+                               echo " *** Trial run, not creating new snapshot in \"$snapshot\"!"
                        fi
                else
                        # No old backup found, create new subvolume
                        if [ "$DRYRUN" -eq 0 ]; then
-                               CreateSubvolume \
-                                 "$sys_target" >/dev/null 2>&1; r=$?
+                               CreateSubvolume "$sys_target"; r=$?
                                if [ $r -ne 0 ]; then
                                        echo "Can't create subvolume \"$sys_target\", code $r!? \"$system\" skipped!"
                                        echo; continue
@@ -333,25 +525,28 @@ for f in $sys; do
        # prepare (remote) command ...
        cmd="rsync --archive"
        [ "$compress" -ne 0 ] && cmd="$cmd --compress"
-       cmd="$cmd --rsh=\"$ssh_cmd\" --delete --delete-excluded --sparse"
+       [ "$local" -eq 0 ] && cmd="$cmd --rsh=\"$ssh_cmd\""
+       cmd="$cmd --delete --delete-excluded --sparse"
        [ "$VERBOSE" -gt 0 ] && cmd="$cmd --progress"
-       cmd="$cmd --exclude=/dev --exclude=/proc --exclude=/sys"
-       cmd="$cmd --exclude=/run --exclude=/tmp --exclude=/var/tmp"
-       cmd="$cmd --exclude=/media --exclude=/mnt --exclude=/net"
-       cmd="$cmd --exclude=/var/cache/apt --exclude=/var/log"
+       if [ "$source_root" = "$default_source_root" ]; then
+               cmd="$cmd --exclude=/dev --exclude=/proc --exclude=/sys"
+               cmd="$cmd --exclude=/run --exclude=/tmp --exclude=/var/tmp"
+               cmd="$cmd --exclude=/media --exclude=/mnt --exclude=/net"
+               cmd="$cmd --exclude=/var/cache/apt --exclude=/var/log"
+       fi
        [ -n "$exclude_args_add" ] && cmd="$cmd $exclude_args_add"
        [ -n "$rsync_args_add" ] && cmd="$cmd $rsync_args_add"
 
        [ "$local" -eq 0 ] \
-               && cmd="$cmd ${user}@${system}:/ $sys_target/" \
-               || cmd="$cmd / $sys_target/"
+               && cmd="$cmd ${user}@${system}:$source_root $sys_target/" \
+               || cmd="$cmd $source_root $sys_target/"
 
        echo "Backing up to \"$sys_target\" ..."
        echo -n "Start date: "; date
        echo "$cmd"
        count_started=$count_started+1
        ok=0
-       
+
        if [ "$DRYRUN" -eq 0 ]; then
                rm -f "$sys_target/.stamp"
                $SHELL -c "$cmd"; ret=$?
@@ -363,8 +558,7 @@ for f in $sys; do
 
        if [ $ret -eq 20 ]; then
                echo "Backup of \"$system\" interrupted. Aborting ..."
-               CleanUp
-               exit 1
+               GotSignal
        fi
 
        echo -n "End date: "; date
@@ -390,10 +584,11 @@ for f in $sys; do
                        ln -s "$sys_target" "$sys_root/latest"
                fi
                # Clean up old generations
-               to_delete=$(ls -1t "$sys_root" 2>/dev/null | tail -n+$generations | sort)
+               declare -i gen_count=$generations+2
+               to_delete=$(ls -1t "$sys_root" 2>/dev/null | tail -n+$gen_count | sort)
                if [ -n "$to_delete" -a $ok -eq 1 ]; then
                        [ "$DRYRUN" -eq 0 ] \
-                               && echo "Deleting old backup generations:" \
+                               && echo "Deleting old backup generations (keep $generations) ..." \
                                || echo " *** Trial run, not deleting old generations:"
                        for delete in $to_delete; do
                                dir="$sys_root/$delete"
@@ -405,10 +600,9 @@ for f in $sys; do
                                 | cut -d':' -f2- | cut -d. -f1)
                                echo "Removing backup from" $last "..."
                                if [ "$DRYRUN" -eq 0 ]; then
-                                       DeleteSubvolume \
-                                        "$dir" >/dev/null 2>&1
+                                       DeleteSubvolume "$dir"
                                        [ $? -eq 0 ] || \
-                                        echo "Failed to delete \"$dir\"!"
+                                         echo "Failed to delete \"$dir\"!"
                                fi
                        done
                        echo -n "Clean up finished: "; date
@@ -425,10 +619,27 @@ done
 
 sync
 
-paths=$( echo $destinations | sed -e 's/ /\n/g' | sort | uniq )
-if [ "$DRYRUN" -eq 0 -a -n "$paths" ]; then
-       df -h $paths
-       echo
+if [ "$DRYRUN" -eq 0 ]; then
+       paths=""
+       paths_zfs=""
+       for dest in $(echo $destinations | sed -e 's/ /\n/g' | sort | uniq); do
+               fs=$(GetFS "$dest")
+               case $fs in
+                 "zfs" )
+                       paths_zfs="$paths_zfs $dest"
+                       ;;
+                 *)
+                       paths="$paths $dest"
+               esac
+       done
+       if [ -n "$paths" ]; then
+               df -h $paths
+               echo
+       fi
+       if [ -n "$paths_zfs" ]; then
+               zfs list $paths_zfs
+               echo
+       fi
 fi
 
 CleanUp
@@ -445,6 +656,9 @@ echo
 if [ $count_started -ne $count_ok ]; then
        echo "----->  THERE HAVE BEEN ERRORS!  <-----"
        echo
+       exit 6
+elif [ $count_all -ne $count_started ]; then
+       exit 7
 fi
 
 # -eof-